/*
 * Licensed to the Apache Software Foundation (ASF) under one or more contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.  The ASF licenses this file to you under the Apache License, Version
 * 2.0 (the "License"); you may not use this file except in compliance with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions
 * and limitations under the License.
 */

package org.apache.storm.container.docker;

import static org.junit.jupiter.api.Assertions.assertEquals;


import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

public class DockerInspectCommandTest {

    private DockerInspectCommand dockerInspectCommand;
    private static final String CONTAINER_NAME = "container_name";

    @BeforeEach
    public void setup() {
        dockerInspectCommand = new DockerInspectCommand(CONTAINER_NAME);
    }

    @Test
    public void getCommandOption() {
        assertEquals("inspect", dockerInspectCommand.getCommandOption());
    }

    @Test
    public void getCommandWithArguments() {
        dockerInspectCommand.withGettingContainerStatus();
        assertEquals("inspect --format='{{.State.Status}}' container_name",
            dockerInspectCommand.getCommandWithArguments());
    }
}